function [X1, X2, X3]=SolveEuler(X10, X20, X30, B1, B2, B3, A11, A12, A13, A21, A22, A23, A31, A32, A33, beta, Re, NBS, nd, nk, yita)
nnx=nd(:,1); nny=nd(:,2); nnz=nd(:,3);
X1=X10;X2=X20;X3=X30;
A=[A11,A12,A13;
   A21,A22,A23;
   A31,A32,A33];
B=[B1;B2;B3];

n=2;
%% =====Use Gauss-Seidel iterative way to solve AX=B=====
%% ===n=1 and eta=0 provides GS4 explicit scheme 
for i=1:n
      RHS1= B1 -A13*X3 -yita*A12*X2;%+ dt*beta/Re*G1*dMu*G1'*X1;
      X1 = sparse(A11)\(RHS1);

      RHS2=B2-A21*X1-A23*X3;
      if yita==1
      X2 = sparse(A22)\(RHS2);   
      else
       X2=0*RHS2;
      end
      R3= B3-A31*X1-yita*A32*X2;  
      if yita==1
      R3(NBS)=2*beta/Re*(...
            X1(NBS).*nnx(NBS).^2  +  X1(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X1(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
            X1(NBS+3*nk).*nnx(NBS).*nny(NBS) + X1(NBS+nk).*nny(NBS).^2  +  X1(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
            X1(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X1(NBS+5*nk).*nny(NBS).*nnz(NBS) +X1(NBS+2*nk).*nnz(NBS).^2)+...
           yita*(X2(NBS).*nnx(NBS).^2  +  X2(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X2(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
            X2(NBS+3*nk).*nnx(NBS).*nny(NBS) + X2(NBS+nk).*nny(NBS).^2  +  X2(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
            X2(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X2(NBS+5*nk).*nny(NBS).*nnz(NBS) +X2(NBS+2*nk).*nnz(NBS).^2);
      else
          R3(NBS)=2*beta/Re*(...
            X1(NBS).*nnx(NBS).^2  +  X1(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X1(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
            X1(NBS+3*nk).*nnx(NBS).*nny(NBS) + X1(NBS+nk).*nny(NBS).^2  +  X1(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
            X1(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X1(NBS+5*nk).*nny(NBS).*nnz(NBS) +X1(NBS+2*nk).*nnz(NBS).^2);
      end
     X3 = sparse(A33)\(R3);
%%============check convergence=======
         X=[X1;X2;X3];B=[B1;B2;B3];
         R=norm(A*X-B);
         if R<=1e-7
             break
         end

end
X=[X1;X2;X3];
end




















 
% for i=1:4
%       R1= G1*vk -dt*G1*dMu*G*X3 + dt*G1*dMu*D*X2;%+ dt*beta/Re*G1*dMu*G1'*X1;
% %       R1(NBS)=0;      R1(NBS+nk)=0;    R1(NBS+2*nk)=0;
% %       R1(NBS+3*nk)=0; R1(NBS+4*nk)=0;  R1(NBS+5*nk)=0;
%       MX1=speye(6*nk)-dt*beta/Re*G1*dMu*D; 
% %       MX1(NBS,:)=0; MX1(NBS+nk,:)=0; MX1(NBS+2*nk,:)=0;
% %       MX1(NBS+3*nk,:)=0; MX1(NBS+4*nk,:)=0; MX1(NBS+5*nk,:)=0;
% %       for j=1:length(NBS)
% %          nbs=NBS(j);
% %          MX1(nbs,nbs)=1; MX1(nbs+nk,nbs+nk)=1;MX1(nbs+2*nk,nbs+2*nk)=1; 
% %          MX1(nbs+3*nk,nbs+3*nk)=1; MX1(nbs+4*nk,nbs+4*nk)=1; MX1(nbs+5*nk,nbs+5*nk)=1; 
% %       end
%      X1 = sparse(MX1)\(R1);
% %      
%       R2=Mt*X20 + dt*Mt*Hk + 2*xi*dt*G1*vk - 2*xi*dt^2*G1*dMu*G*X3 + 2*xi*dt^2*beta/Re*G1*dMu*D*X1;%+ 2*xi*dt^2*G1*dMu*G1'*X2;
% %     % R2(NBS)=2*beta/Re*X1(NBS);R2(NBS+nk)=2*beta/Re*X1(NBS+nk);R2(NBS+2*nk)=2*beta/Re*X1(NBS+2*nk);
% %      R2(NBS)=0;      R2(NBS+nk)=0;   R2(NBS+2*nk)=0;
% %      R2(NBS+3*nk)=0; R2(NBS+4*nk)=0; R2(NBS+5*nk)=0;
%      MX2=Mt+ A22d - 2*xi*dt^2*G1*dMu*D; 
% %      MX2(NBS,:)=0; MX2(NBS+nk,:)=0; MX2(NBS+2*nk,:)=0;
% %      MX2(NBS+3*nk,:)=0; MX2(NBS+4*nk,:)=0; MX2(NBS+5*nk,:)=0;
% %      for j=1:length(NBS)
% %          nbs=NBS(j);
% %          MX2(nbs,nbs)=1; MX2(nbs+nk,nbs+nk)=1; MX2(nbs+2*nk,nbs+2*nk)=1;
% %          MX2(nbs+3*nk,nbs+3*nk)=1; MX2(nbs+4*nk,nbs+4*nk)=1; MX2(nbs+5*nk,nbs+5*nk)=1; 
% %      end
%       X2 = sparse(MX2)\(R2);   
% %         
%      
%      R3= G'*vk+ dt*beta/Re*G'*dMu*D*X1 + dt*G'*dMu*D*X2;  
%      R3(NBS)=2*beta/Re*(...
%             X1(NBS).*nnx(NBS).^2  +  X1(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X1(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
%             X1(NBS+3*nk).*nnx(NBS).*nny(NBS) + X1(NBS+nk).*nny(NBS).^2  +  X1(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
%             X1(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X1(NBS+5*nk).*nny(NBS).*nnz(NBS) +X1(NBS+2*nk).*nnz(NBS).^2)+...
%            (X2(NBS).*nnx(NBS).^2  +  X2(NBS+3*nk).*nnx(NBS).*nny(NBS)   +  X2(NBS+4*nk).*nnx(NBS).*nnz(NBS)+...
%             X2(NBS+3*nk).*nnx(NBS).*nny(NBS) + X2(NBS+nk).*nny(NBS).^2  +  X2(NBS+5*nk).*nny(NBS).*nnz(NBS)+...
%             X2(NBS+4*nk).*nnx(NBS).*nnz(NBS) + X2(NBS+5*nk).*nny(NBS).*nnz(NBS) +X2(NBS+2*nk).*nnz(NBS).^2);
% 
%      MX3=(dt*G'*dMu*G);  
%      MX3(NBS,:)=0; 
%      for j=1:length(NBS)
%          nbs=NBS(j);
%          MX3(nbs,nbs)=1;
%      end
%      X3 = sparse(MX3)\(R3);
% 