function [xp,vp,Tp,pp]=maptopointsPC(Ng,Tg,xmin,nexyz,Np,xp,vp,icon,vnew,v,dx,dt,p, Fr,g)
% get natural coordinates of particles within cell
[xpn,nep]=natcoords(xp,dx,xmin,nexyz);

vnew = [vnew(1:Ng,:),vnew(Ng+1:2*Ng,:),vnew(2*Ng+1:3*Ng,:)];
v = [v(1:Ng,:),v(Ng+1:2*Ng,:),v(2*Ng+1:3*Ng,:)];
pp = zeros(Np,1); Tp=zeros(Np,6); xpF = zeros(3,Np);
k1=zeros(3,Np); k2=zeros(3,Np); k3=zeros(3,Np); k4=zeros(3,Np);

%%% RK4
for ip=1:Np
    i=nep(ip);
    iv=icon(:,i);
    n=shape3D(xpn(1,ip),xpn(2,ip),xpn(3,ip));
    
    k1(1,ip) = v(iv,1)'*n; 
    k1(2,ip) = v(iv,2)'*n;
    k1(3,ip) = v(iv,3)'*n;
    xpF(1,ip) = xp(1,ip) +  k1(1,ip) *dt/2;
    xpF(2,ip) = xp(2,ip) +  k1(2,ip) *dt/2;  
    xpF(3,ip) = xp(3,ip) +  k1(3,ip) *dt/2; 
    [xpn2,nep2] = natcoords(xpF(:,ip),dx,xmin,nexyz);
    i2 = nep2(1); iv2 = icon(:,i2); nn = shape3D(xpn2(1),xpn2(2),xpn2(3));
    k2(1,ip) = 0.5*(vnew(iv2,1)+v(iv2,1))'*nn;
    k2(2,ip) = 0.5*(vnew(iv2,2)+v(iv2,2))'*nn;
    k2(3,ip) = 0.5*(vnew(iv2,3)+v(iv2,3))'*nn;
    
    xpF(1,ip) = xp(1,ip) +  k2(1,ip) *dt/2;
    xpF(2,ip) = xp(2,ip) +  k2(2,ip) *dt/2;   
    xpF(3,ip) = xp(3,ip) +  k2(3,ip) *dt/2;  
    [xpn2,nep2] = natcoords(xpF(:,ip),dx,xmin,nexyz);
    i2 = nep2(1); iv2 = icon(:,i2); nn = shape3D(xpn2(1),xpn2(2),xpn2(3));
    k3(1,ip) = 0.5*(vnew(iv2,1)+v(iv2,1))'*nn;
    k3(2,ip) = 0.5*(vnew(iv2,2)+v(iv2,2))'*nn;
    k3(3,ip) = 0.5*(vnew(iv2,3)+v(iv2,3))'*nn;
    
    xpF(1,ip) = xp(1,ip) +  k3(1,ip) *dt;
    xpF(2,ip) = xp(2,ip) +  k3(2,ip) *dt;
    xpF(3,ip) = xp(3,ip) +  k3(3,ip) *dt;
    [xpn2,nep2] = natcoords(xpF(:,ip),dx,xmin,nexyz);
    i2 = nep2(1); iv2 = icon(:,i2); nn = shape3D(xpn2(1),xpn2(2),xpn2(3));
    k4(1,ip) = vnew(iv2,1)'*nn;
    k4(2,ip) = vnew(iv2,2)'*nn;
    k4(3,ip) = vnew(iv2,3)'*nn;
    
    xp(1,ip) = xp(1,ip) + dt*(k1(1,ip)/6 + k2(1,ip)/3 + k3(1,ip)/3 + k4(1,ip)/6);
    xp(2,ip) = xp(2,ip) + dt*(k1(2,ip)/6 + k2(2,ip)/3 + k3(2,ip)/3 + k4(2,ip)/6);
    xp(3,ip) = xp(3,ip) + dt*(k1(3,ip)/6 + k2(3,ip)/3 + k3(3,ip)/3 + k4(3,ip)/6)+1/2*g/Fr^2*dt^2;


   vp(1,ip)=(k1(1,ip)/6 + k2(1,ip)/3 + k3(1,ip)/3 + k4(1,ip)/6);
   vp(2,ip)=(k1(2,ip)/6 + k2(2,ip)/3 + k3(2,ip)/3 + k4(2,ip)/6);
   vp(3,ip)=(k1(3,ip)/6 + k2(3,ip)/3 + k3(3,ip)/3 + k4(3,ip)/6)+g/Fr^2*dt;
   
    %%% Update stress
    nPressure = p(iv);
    pp(ip) = nPressure'*n;  
    T1=Tg(iv)'*n;
    T2=Tg(iv+Ng)'*n;
    T3=Tg(iv+2*Ng)'*n;
    T4=Tg(iv+3*Ng)'*n;
    T5=Tg(iv+4*Ng)'*n;
    T6=Tg(iv+5*Ng)'*n; 
    Tp(ip,:) = [T1, T2, T3, T4, T5, T6];  
end
end

