function [M, K, Gx, Gy, Gz] = FEMmatrix3D(Ne, Ng, con, Lx, Ly, Lz)
    M=zeros(Ng);    K=zeros(Ng);    Gx=M; Gy=M; Gz=M;
    Me=[8, 4, 2, 4, 4, 2, 1, 2;
       4, 8, 4, 2, 2, 4, 2, 1; 
       2, 4, 8, 4, 1, 2, 4, 2; 
       4, 2, 4, 8, 2, 1, 2, 4;
       4, 2, 1, 2, 8, 4, 2, 4; 
       2, 4, 2, 1, 4, 8, 4, 2; 
       1, 2, 4, 2, 2, 4, 8, 4; 
       2, 1, 2, 4, 4, 2, 4, 8]*Lx*Ly*Lz/8/27;
    Kxe=[4, -4, -2,  2,  2, -2, -1,  1;
       -4,  4,  2, -2, -2,  2,  1, -1;
       -2,  2,  4, -4, -1,  1,  2, -2;
        2, -2, -4,  4,  1, -1, -2,  2;
        2, -2, -1,  1,  4, -4, -2,  2;
       -2,  2,  1, -1, -4,  4,  2, -2;
       -1,  1,  2, -2, -2,  2,  4, -4;
        1, -1, -2,  2,  2, -2, -4,  4]*Ly*Lz/Lx/2/18;
    Kye=[ 4,  2, -2, -4,  2,  1, -1, -2;
          2,  4, -4, -2,  1,  2, -2, -1;
         -2, -4,  4,  2, -1, -2,  2,  1;
         -4, -2,  2,  4, -2, -1,  1,  2;
          2,  1, -1, -2,  4,  2, -2, -4;
          1,  2, -2, -1,  2,  4, -4, -2;
         -1, -2,  2,  1, -2, -4,  4,  2;
         -2, -1,  1,  2, -4, -2,  2,  4]*Lx*Lz/Ly/2/18;
    Kze=[ 4,  2,  1,  2, -4, -2, -1, -2;
          2,  4,  2,  1, -2, -4, -2, -1; 
          1,  2,  4,  2, -1, -2, -4, -2;
          2,  1,  2,  4, -2, -1, -2, -4;
         -4, -2, -1, -2,  4,  2,  1,  2;
         -2, -4, -2, -1,  2,  4,  2,  1;
         -1, -2, -4, -2,  1,  2,  4,  2;
         -2, -1, -2, -4,  2,  1,  2,  4]*Lx*Ly/Lz/2/18;
     Ke=Kxe+Kye+Kze;
     Gxe=[ -4, 4, 2, -2, -2, 2, 1, -1; 
           -4, 4, 2, -2, -2, 2, 1, -1;
           -2, 2, 4, -4, -1, 1, 2, -2;
           -2, 2, 4, -4, -1, 1, 2, -2; 
           -2, 2, 1, -1, -4, 4, 2, -2;
           -2, 2, 1, -1, -4, 4, 2, -2; 
           -1, 1, 2, -2, -2, 2, 4, -4; 
           -1, 1, 2, -2, -2, 2, 4, -4]*Ly*Lz/4/18;
    Gye=[ -4, -2, 2, 4, -2, -1, 1, 2; 
          -2, -4, 4, 2, -1, -2, 2, 1; 
          -2, -4, 4, 2, -1, -2, 2, 1;
          -4, -2, 2, 4, -2, -1, 1, 2;
          -2, -1, 1, 2, -4, -2, 2, 4;
          -1, -2, 2, 1, -2, -4, 4, 2; 
          -1, -2, 2, 1, -2, -4, 4, 2;
          -2, -1, 1, 2, -4, -2, 2, 4]*Lx*Lz/4/18;
    Gze =[ -4, -2, -1, -2, 4, 2, 1, 2; 
           -2, -4, -2, -1, 2, 4, 2, 1; 
           -1, -2, -4, -2, 1, 2, 4, 2;
           -2, -1, -2, -4, 2, 1, 2, 4;
           -4, -2, -1, -2, 4, 2, 1, 2;
           -2, -4, -2, -1, 2, 4, 2, 1;
           -1, -2, -4, -2, 1, 2, 4, 2;
           -2, -1, -2, -4, 2, 1, 2, 4]*Lx*Ly/4/18;
    for h=1:Ne
        id=con(:,h);
        M(id,id)=M(id,id)+Me;
        K(id,id)=K(id,id)+Ke;
        Gx(id,id)=Gx(id,id)+Gxe;
        Gy(id,id)=Gy(id,id)+Gye;
        Gz(id,id)=Gz(id,id)+Gze;
    end
    M=sparse(M);
    K=sparse(K);
    Gx=sparse(Gx);
    Gy=sparse(Gy);
    Gz=sparse(Gz);
end

