clc; clear; close all;
% problem inputs
%% ====time stepping====
dt=2e-4;%CFL * min(lx,ly)/1;
t=0;Tmax =100.0;
Tmax=Tmax+dt;
rmin=0; rmax=1; rs=0; alg=1;alp=0.5; eta=1; yita=1; % eta=1: implicit eta=0: explicit;  yita=0: Newtonian yita=1: non-Newtonian
[L1W1, L2W2, L3W3, L4W1, L5W2, L6W1, lam1, lam2, lam3, lam4, lam5, W1]=GS4_2_param(rmin, rmax, rs, alg);
%% ===========Flow parameters===============
Re=1e-2; beta=0.5;alph=0.5;gamma=0.9;Q0=20;We=1; 
xi=(1-beta)/(Re*We);
g=0;Fr=0.1;
v0=-100;
% alp=alp*beta;
%% ========space discretization==================
xa=0; xb=1; % x direction 
ya=0; yb=1; % y direction
za=0; zb=1; % z direction
nx=10; ny=10; nz=10; % elements at x-y-z directions
Ne=nx*ny*nz; % total elemennts
Ng=(nx+1)*(ny+1)*(nz+1); % total nodes
Lx=(xb-xa)/nx; % dx 
Ly=(yb-ya)/ny; % dy
Lz=(zb-za)/nz; % dz 
%% ======Ordering: (1) x y loop (2) z loop 
xe=(xa : Lx : xb)'; Ix=ones(nx+1,1); % xe: x position sampling
ye=(ya : Ly : yb)'; Iy=ones(ny+1,1); % ye: y position sampling
ze=(za : Lz : zb)'; Iz=ones(nz+1,1); % ze: z position sampling
xg=kron(Iz,kron(Iy,xe)); % xg: all nodes x position
yg=kron(Iz,kron(ye,Ix));% yg: all nodes x position
zg=kron(ze,kron(Iy,Ix));% yg: all nodes x position
%%==================
xmin=[xa,ya,za]; dx=[Lx,Ly,Lz]; nexyz=[nx,ny,ny];
Xg=[xg, yg, zg]; %all nodes position
Vg=zeros(3*Ng,1); % velocity on the grids- vector [Vx; Vy; Vz];
VBC=0*Vg; % BC value
%% connectivity matrix
icon=zeros(8, Ne);
%====first four nodes label on x-y layer======
for k=1:nz
    for j=1:ny
        for i=1:nx
            e=(k-1)*ny*nx + (j-1)*nx + i;
            icon(1,e) = (k-1)*(nx+1)*(ny+1) + (j-1)*(nx+1) + i;
            icon(2,e) = icon(1,e)+1;
            icon(3,e) = icon(2,e)+nx+1;
            icon(4,e) = icon(3,e)-1;
        end
    end
end
%=====adding one x-y face total nodes to get other four nodes
icon(5:8,:) = icon(1:4,:) + (nx+1)*(ny+1); %   
%% iniitalize the material point
nep=[8,8,8];
[Np, xp, vp]= InitialParticle(nep, dx, icon, Xg, Ne);  
Tp=zeros(Np,6);
pp=zeros(Np,1);
%===========================================
figure('Name', 'Initial mesh grid and mp');
% hold on; pbaspect([1 1 1]);
% for j=1:Ne
%     id=icon(:,j);    id=[id; id(1)];
%     plot3(Xg(id,1), Xg(id,2), Xg(id,3), 'r.', 'LineWidth', 1)
% end
%% === boundary setup======================
ntop=find(Xg(:,3)>=1);
nbot=find(Xg(:,3)<=0);
nright=find(Xg(:,1)>=1);
nleft=find(Xg(:,1)<=0);
nfront=find(Xg(:,2)<=0);
nback=find(Xg(:,2)>=1);
NBCv=[nbot+2*Ng];
%% =============Assemble Matrix============
[M, K, Gx, Gy, Gz] = FEMmatrix3D(Ne, Ng, icon, Lx, Ly, Lz);    
zer=0*Gx;
G10= sparse([Gx,  zer,zer;
             zer, Gy, zer;
             zer, zer, Gz;
            0.5*Gy, 0.5* Gx, zer;
           0.5*Gz, zer, 0.5*Gx;
           zer, 0.5* Gz,  0.5*Gy]); %===Gradient of Velocity
G20= sparse([Gx; Gy; Gz]); %=====Gradient of P  
G30= sparse([Gx,  zer, zer, Gy, Gz, zer;
           zer, Gy,  zer, Gz, zer, Gx;
           zer, zer, Gz,  zer, Gx, Gy]); %==Divergence of stress
% full scale matrix==
Mu0=[ M,zer, zer;
    zer, M, zer;
    zer, zer, M];% mass matrix
Mt0=[ M, zer, zer, zer, zer, zer;
    zer, M, zer, zer, zer, zer;
    zer, zer, M, zer, zer, zer;
    zer, zer, zer, M, zer, zer;
    zer, zer, zer, zer, M, zer;
    zer, zer, zer, zer, zer, M];
Mu=(sum(Mu0,2));
dMu=sparse(diag(1./Mu));
Mt0=diag(sum(Mt0,2));
%=================
 p=zeros(Ng,1); 
 vp(3,:)=v0; % initial particle velocity
 step=0;
 tic
 ap=0*vp; ap(3,:)=g/Fr^2; dTp=0*Tp;
while(step<=60)  
    step=step+1;
    %====Algorithmic variavles
    xpp=xp+L1W1*vp*dt+L2W2*ap*dt^2;
    vpp=vp+L4W1*ap*dt;
    app=ap;
    Tpp=Tp+L4W1*dTp*dt;
    dTpp=dTp;
    %%======= Particle to grid%%%%%
    [xpn, nep]=natcoords(xp,dx,xmin,nexyz);
    [mv,v,a,vg, ag, T, Tg, dT, dTg, p,nn]=P2G(Ng,icon,xpn,nep,Np,vpp, app, Tpp, ap, vp, Tp, dTp, dTpp, pp);
    for i=1:length(NBCv)
        if vg(NBCv(i))<0        
        v(NBCv(i)) = VBC(NBCv(i));
        vg(NBCv(i)) = VBC(NBCv(i));
        end
    end
    %% ====
    [Hg,f]=Hstar(Tg, alph, gamma, Q0, xi, We, Ng, G10, vg, Mt0);
    [Mf, A22d]=massA2(dx, Ng, Ne, icon, f, We, dt); 
  %% =====grids elimiation=====
      NBC=find(nn<=0);  % NBC: non particle nodes, NBS: free surface nodes  
      Phi=speye(Ng); Phi(:,NBC)=[];
      dxm=Phi'*Gx*Phi; dym=Phi'*Gy*Phi; dzm=Phi'*Gz*Phi;  
      nk=length(dxm);Ck=Phi'*M*Phi; zk=zeros(nk);
      [G1, D, G, Mu, Md, Mt, dMu, A22d]=full_scale_operators(dxm, dym, dzm, Ck, Mf, Phi, zk);     
      [Nk, vk,ank, Hk, Tk, Tnk, dTnk, dTk, pk, znk]=Matrix_reduction(nn, nk, Ng, Phi, vg, a, Hg, Tg, T, dT, dTg, p);
  %% ==========Free Surface================
   Gnx=dxm*Nk;   Gny=dym*Nk; Gnz=dzm*Nk;
   Gn=sqrt(Gnx.*Gnx+Gny.*Gny+Gnz.*Gnz);
   nnx=Gnx./(Gn); nny=Gny./(Gn); nnz=Gnz./(Gn);
   NBS=find(Gn>1e-8); nd=[nnx, nny, nnz];
   X10=G1*vk; X20=Tk; X30=pk;
  %% ===========Solve ============
   [A11, A12, A13, A21, A22, A23, A31, A32, A33, B1, B2, B3]= SolveAssemble(X20, Hk, dMu, Mt, A22d, NBS, beta, Re, G1, D, G, xi, L5W2, L6W1, lam1, nk, vk, dt);
   [X1, X2, X3]=SolveGS4(X10, X20, X30, B1, B2, B3, A11, A12, A13, A21, A22, A23, A31, A32, A33, L5W2, L6W1, beta, Re, NBS, nd, nk, eta, yita);
  %% ==========Results Reterive====
  L6W1=(3+rmin+rs-rmin*rs)/(2*(1+rmin)*(1+rs));
    zn=zeros(Ng,nk);
    deltT=(yita*[Phi, zn, zn, zn, zn, zn ;
        zn, Phi, zn, zn, zn, zn ;
        zn, zn, Phi, zn, zn, zn;
        zn, zn, zn, Phi, zn, zn ;
        zn, zn, zn, zn, Phi, zn ;
        zn, zn, zn, zn, zn, Phi ]*(X2-X20)/dt-dT)/L6W1;
    p=Phi*X3;  
    dA=(dMu*(beta/Re*D*X1+ yita*L5W2*D*X2- G*X3)-ank)/L6W1;
    deltA=[Phi, zn, zn;
           zn, Phi, zn;
           zn, zn, Phi]*dA;
  %% ======algorithmic time level on grids=======
    vg=vg+L5W2*deltA*dt;
    Tg=Tg+L5W2*deltT*dt;
    
    agp=a+deltA;
    vgp=v+lam4*a*dt+lam5*deltA*dt;
    dTgp=dT+deltT;
    Tgp=T+lam4*dT*dt+lam5*deltT*dt;
    
    agp=[agp(1:Ng),agp(Ng+1:2*Ng),agp(2*Ng+1:3*Ng)];
    vgp=[vgp(1:Ng),vgp(Ng+1:2*Ng),vgp(2*Ng+1:3*Ng)];
    deltA=[deltA(1:Ng),deltA(Ng+1:2*Ng),deltA(2*Ng+1:3*Ng)];
    
    dTgp=[dTgp(1:Ng),dTgp(Ng+1:2*Ng),dTgp(2*Ng+1:3*Ng),dTgp(3*Ng+1:4*Ng),dTgp(4*Ng+1:5*Ng),dTgp(5*Ng+1:6*Ng)];
    Tgp=[Tgp(1:Ng),Tgp(Ng+1:2*Ng),Tgp(2*Ng+1:3*Ng),Tgp(3*Ng+1:4*Ng),Tgp(4*Ng+1:5*Ng),Tgp(5*Ng+1:6*Ng)];
    deltT=[deltT(1:Ng),deltT(Ng+1:2*Ng),deltT(2*Ng+1:3*Ng),deltT(3*Ng+1:4*Ng),deltT(4*Ng+1:5*Ng),deltT(5*Ng+1:6*Ng)];
   %% ========= Boundary Condition==========
     for i=1:length(NBCv)
        if vg(NBCv(i))<0        
        vgp(NBCv(i)) = VBC(NBCv(i));
        end
     end
    %% ===== Grids to Particles=============
    [xp,vp,ap, dTp, Tp, pp]=maptopointsPC(Np,nep,xpn,icon,Ng,xp,vp,ap,dTp,Tp,vgp,agp,deltA,Tgp,dTgp,deltT,dt,lam1,lam2,lam3,lam4,lam5,alp,p);
    v=vgp;  
    %% ====Plot======
    if mod(step, 5)==0
    clf  
    plot3(xp(1,:), xp(2,:), xp(3,:), 'b.', 'LineWidth', 2) 
    axis([0.2 0.8 0.2 0.8 0 0.3])
    xlabel('X'); ylabel('Y'); zlabel('Z')
    view(-53, 49)
   %  saveas(figure(1),sprintf('figure_%d.fig',step))
   % view(0, 1)
    drawnow
    end
    %     
end
toc  
