function [C, M] = massA2( dx, Ng, Ne, icon, F, We, dt )
    Lx=dx(1); Ly=dx(2); Lz=dx(3);
    C=zeros(Ng,Ng); %Npt*Np on all elements 
    Me=[8, 4, 2, 4, 4, 2, 1, 2;
       4, 8, 4, 2, 2, 4, 2, 1; 
       2, 4, 8, 4, 1, 2, 4, 2; 
       4, 2, 4, 8, 2, 1, 2, 4;
       4, 2, 1, 2, 8, 4, 2, 4; 
       2, 4, 2, 1, 4, 8, 4, 2; 
       1, 2, 4, 2, 2, 4, 8, 4; 
       2, 1, 2, 4, 4, 2, 4, 8]*Lx*Ly*Lz/8/27;      
    for i=1:Ne
        nodes=icon(:,i);
        f=dt*sum(F(nodes))/8/We;
        C(nodes,nodes)=C(nodes,nodes)+f*Me;    
    end 
    C=sparse(C); z=zeros(Ng);
    M=[C, z, z, z, z, z;
       z, C, z, z, z, z;
       z, z, C, z, z, z;
       z, z, z, C, z, z;
       z, z, z, z, z, C];
    
end %end function
